Subject: Re: [PATCH bpf] libbpf: Sanitise internal map names so they are not rejected by the kernel

From: Toke Høiland-Jørgensen <[email-masked]>
Date: Tue, 18 Feb 2020 17:42:00 +0100

Yonghong Song <[email-masked]> writes:

> On 2/18/20 6:40 AM, Daniel Borkmann wrote:
>> On 2/17/20 6:17 PM, Toke Høiland-Jørgensen wrote:
>>> The kernel only accepts map names with alphanumeric characters, 
>>> underscores
>>> and periods in their name. However, the auto-generated internal map names
>>> used by libbpf takes their prefix from the user-supplied BPF object name,
>>> which has no such restriction. This can lead to "Invalid argument" errors
>>> when trying to load a BPF program using global variables.
>>>
>>> Fix this by sanitising the map names, replacing any non-allowed 
>>> characters
>>> with underscores.
>>>
>>> Fixes: d859900c4c56 ("bpf, libbpf: support global data/bss/rodata 
>>> sections")
>>> Signed-off-by: Toke Høiland-Jørgensen <[email-masked]>
>> 
>> Makes sense to me, applied, thanks! I presume you had something like '-' 
>> in the
>> global var leading to rejection?
>
> The C global variable cannot have '-'. I saw a complain in bcc mailing 
> list sometimes back like: if an object file is a-b.o, then we will 
> generate a map name like a-b.bss for the bss ELF section data. The
> map name "a-b.bss" name will be rejected by the kernel. The workaround
> is to change object file name. Not sure whether this is the only
> issue which may introduce non [a-zA-Z0-9_] or not. But this patch indeed 
> should fix the issue I just described.

Yes, this was exactly my problem; my object file is called
'xdp-dispatcher.o'. Fun error to track down :P

Why doesn't the kernel allow dashes in the name anyway?

-Toke